// sdf.sys.txt.js

post();
post("sdf.sys.txt.js");


autowatch = 1;

inlets = 4;
	setinletassist (0, "bang");
	setinletassist (1, "ASCII number");
	setinletassist (2, "number of modifier keys held");
	setinletassist (3, "bang for next line of txt");

outlets = 4;
	setoutletassist (0, "txtBuffer");
	setoutletassist (1, "txtCursor");
	setoutletassist (2, "txtSelect");
	setoutletassist (3, "indices of lines of txt");


// ===== Global Vars, Maps etc =====

var jsG = new Global("jsGlobal");
jsG.modifiers = 0;

x = "x";
y = "y";
abs = "abs";

	
atoi = {	
	"backspace":8, "delete":127, "return":13, "enter":3, "esc":27,
	"left":28, "right":29, "up":30, "down":31, 
	"!":33, "\\":34, "#":35, "$":36, "%":37, "&":38, "'":39, "(":40,
	")":41, "*":42, "+":43, ",":44, "-":45, ".":46, "/":47, "0":48, 
	"1":49, "2":50, "3":51, "4":52, "5":53, "6":54, "7":55, "8":56, 
	"9":57, ":":58, "\;":59, "<":60, ":":61, ">":62, "?":63, "@":64, 
	"A":65, "B":66, "C":67, "D":68, "E":69, "F":70, "G":71, "H":72, 
	"I":73, "J":74, "K":75, "L":76, "M":77, "N":78, "O":79, "P":80, 
	"Q":81, "R":82, "S":83, "T":84, "U":85, "V":86, "W":87, "X":88, 
	"Y":89, "Z":90, "[":91, "\\":92, "]":93, "^":94, "_":95, "`":96, 
	"a":97, "b":98, "c":99, "d":100, "e":101, "f":102, "g":103, "h":104, 
	"i":105, "j":106, "k":107, "l":108, "m":109, "n":110, "o":111, "p":112, 
	"q":113, "r":114, "s":115, "t":116, "u":117, "v":118, "w":119, "x":120, 
	"y":121, "z":122, "{":123, "|":124, "}":125, "~":126
};

cursor = { "x":0, "y":0 };


// ===== Jitter Matrices =====

m_size = { "x":64, "y":32 };

var m_txtBuffer = new JitterMatrix("txtBuffer", 1, "char", m_size.x, m_size.y);
var m_txtCursor = new JitterMatrix("txtCursor", 1, "char", m_size.x, m_size.y);
var m_txtSelect = new JitterMatrix("txtSelect", 1, "char", m_size.x, m_size.y);
var m_txtBackup = new JitterMatrix("txtBackup", 1, "char", m_size.x, m_size.y);

function m_init()
{
	m_txtBuffer.setall( 32 );
	m_txtCursor.setall( 32 );
	m_txtSelect.setall( 32 );
	m_txtBackup.setall( 66 );
}
m_init();

function m_output()
{
	outlet(2, "jit_matrix", m_txtSelect.name);
	outlet(1, "jit_matrix", m_txtCursor.name);
	outlet(0, "jit_matrix", m_txtBuffer.name);
}//end function m_output()

var m_txtLine = new JitterMatrix("txtLine", 1, "char", m_size.x, 1);


// ===== Jitter Objects =====

var submatrix1 = new JitterObject("jit.submatrix");
submatrix1.dim = [m_size.x,1];
submatrix1.offset = [0,0];



// ===== Functions =====


function bang()
{
	if (activeFlag)
	{/*
		if (inlet == 3)
		{	nextLine(); 
		}
	*/
	}//end  if (activeFlag)
}// end function msg_int()

var lineIndex = 0;

function nextLine()
{
post(lineIndex);
	submatrix1.offset = [0,lineIndex];
	submatrix1.matrixcalc(m_txtBuffer,m_txtLine);
	outlet(3, "jit_matrix", m_txtLine.name);
	lineIndex++;
}//end function nextLine()

function msg_int()
{
	if (activeFlag)
	{
		if (inlet == 2) jsG.modifiers = arguments[0];
		if (inlet == 1)
		{	if( jsG.modifiers < 2 ) qwertyKeyDown(arguments[0]);
			else doubleMod(arguments[0]);
		}
	}//end  if (activeFlag)
}// end function msg_int()

function qwertyKeyDown(asciiNum)
{
	if (asciiNum == atoi["backspace"] ){
		if ( cursor.x > 0)
		{
			cursorMove(x, -1);
			deleteChar();
		}
	}//end if backspace
	else if (asciiNum == atoi["delete"] ){
		deleteChar();
	}//end if delete
	else if (asciiNum == atoi["left"]){ 
		cursorMove(x,-1); // move left
		if (cursor.x < 0) // if moved to sub start of line
		{
			if (cursor.y > 0) //if not top line
			{
				cursorMove(y,-1);
				// find end of text...
					i = m_size.x-1;			
					cursorMove(abs,i,cursor.y);
					while( m_txtBuffer.getcell(i,cursor.y) == 32)
					{ i--; } //end while
				cursorMove(abs,i+1,cursor.y);	
			}//end if not top line
			else{ //if top line
				cursorMove(abs,0,0); }
		}// end if moved to sub start of line
	}//end if left
	else if (asciiNum == atoi["right"]){ 
		if ( cursor.x < m_size.x-1 ) cursorMove(x,1); 
	}//end if right
	else if (asciiNum == atoi["up"]){ 
		if ( cursor.y > 0 ) cursorMove(y,-1); 
	}//end if up
	else if (asciiNum == atoi["down"]){ 
		if ( cursor.y < m_size.y-1 ) cursorMove(y,1);
	}//end if down
	else if (asciiNum == atoi["delete"]){}//end if delete
	else if (asciiNum == atoi["return"]){ 
		cursorMove(abs,0,cursor.y+1);	}//end if return
	else if (asciiNum == atoi["enter"]){}//end if enter
	else if (asciiNum == atoi["esc"]){}//end if esc
	else {
		insertChar(asciiNum);
	}//end if not filtered	
}// end function qwertyKeyDown(asciiNum)

function deleteChar()
{
	if ( cursor.x >= 0 )
		{
			for( i = cursor.x; i < m_size.x-2; i++)
			{// shift char's right of cursor one to left (over writting this cell)
				temp = m_txtBuffer.getcell(i+1,cursor.y);
				m_txtBuffer.setcell2d( i, cursor.y, temp );
			}//end for char shifting
			
			outlet(0, "jit_matrix", m_txtBuffer.name);
			// cursorMove(x,-1);
		}
}// end function deleteChar()
function insertChar(asciiNum)
{
	for(i=m_size.x-1; i>cursor.x; i--)
	{
		temp = m_txtBuffer.getcell(i-1,cursor.y);
		m_txtBuffer.setcell2d( i, cursor.y, temp );
	}//end for char shifting
	m_txtBuffer.setcell2d( cursor.x, cursor.y, asciiNum );
	cursorMove(x, 1);
	outlet(0, "jit_matrix", m_txtBuffer.name);
}// end function insertChar(aNum)

function cursorMove(dim, val)
{
	if (activeFlag) updateCursor(32); // clear pos before moving
	if (dim==abs){
		cursor.x = arguments[1];
		cursor.y = arguments[2];
	}//end if absolute move
	else {
		cursor[dim] += val;
	}//end relative move in one dim	
		if (activeFlag) updateCursor(95); // show new pos 

}//end function cursorNav(moveType)

function doubleMod(asciiNum)
{
	if (asciiNum == atoi["backspace"]  || asciiNum == atoi["delete"]){
	clear();
	}//end if backspace
	else if (asciiNum == atoi["right"])
	{ 	selectLine(cursor.y);	
		cursorMove(abs,0,cursor.y);
	}//end if left
	else if (asciiNum == atoi["left"])
	{	deselectLine(cursor.y);	
		cursorMove(abs,0,cursor.y);
	}//end if right
	else if (asciiNum == atoi["up"])
	{ 	selectLine(cursor.y);	
		cursorMove(y,-1);
		if (cursor.y < 0) cursorMove(abs,0,0);
	}//end if up
	else if (asciiNum == atoi["down"])
	{	selectLine(cursor.y);	
		cursorMove(y,1);
		if (cursor.y > m_size.y-1) cursorMove(abs,0,m_size.y-1);
	}//end if down
	else if (asciiNum == atoi["return"])
	{ 
		// qwertyKeyDown(asciiNum);
		outlet(3, "bang");
	}//end if return
	else if (asciiNum == atoi["enter"]){}//end if enter
	else if (asciiNum == atoi["esc"])
	{ 	m_txtSelect.setall(32); // deselect all
		m_output();
	}//end if esc
	
}// end function doubleModified(asciiNum)



function selectLine(lineIndex) 
{
	// find end of text...
		i = m_size.x-1;			
		cursorMove(abs,i,cursor.y);
		while( m_txtBuffer.getcell(i,lineIndex) == 32)
		{ 
			i--; 
		} //end while
		if (i>-1) // if line not blank	
		{
			for(j=0;j<i+1;j++)
			{	m_txtSelect.setcell2d( j, lineIndex, 95 ); 
			}
			outlet(2, "jit_matrix", m_txtSelect.name);
		}// end if line not blank	
		
	cursorMove(abs,0,cursor.y);
}// end function selectLine(lineIndex)

function deselectLine(lineIndex)
{

	for( i=0; i<m_size.x; i++ )
	{	m_txtSelect.setcell2d( i, cursor.y, 32 ); 
	}
	outlet(2, "jit_matrix", m_txtSelect.name);	
	cursorMove(abs,0,cursor.y);
}// end function selectLine(lineIndex)


var numLineIdicessDumped = 0;
function dumpSelectedLinesIndices()
{ /*
	for (i=0;i<m_size.y;i++)
	{
		if ( m_txtSelect.getcell(0,i) != 32 ) // if line selected
		{
			outlet(3, i);
			numLineIdicessDumped++;
		}//end if line selected
	} //end for num lines
	*/
	post();
	post("dump");
}//end function dumpSelectedLinesIndices()



// ===== Task Management =====

// /*
var cursorTask = new Task(cursorBlink);
    cursorTask.interval = 456; 
// */
var activeFlag = false;

function active(toggle){
	if(toggle == 1)
	{
		cursorTask.repeat(-1,0); 
		updateCursor(95);
		activeFlag = true; 
		jsG.activeSpaces[0] = 1; //forces flag toggle behaviour on space 0
		m_output(); 
		outlet(0, "enable", 1);
		outlet(1, "enable", 1);
		outlet(2, "enable", 0); // not using the selection layer for now
	}
	else
	{
		cursorTask.cancel(); 
		activeFlag = false; 
		updateCursor(32); 
		outlet(0, "enable", 0);
		outlet(1, "enable", 0);
		outlet(2, "enable", 0); 
	}
}// end function active(toggle)


function updateCursor(aInt) 
{
	m_txtCursor.setcell2d( cursor.x, cursor.y, aInt );
	outlet(1, "jit_matrix", m_txtCursor.name);
}//end updateCursor(aInt)

var cBlinky = 32;

function cursorBlink() // === the main task function ===  
{
	if (cBlinky==32) cBlinky = 95;
	else cBlinky = 32;
	m_txtCursor.setcell2d( cursor.x, cursor.y, cBlinky );
	outlet(1, "jit_matrix", m_txtCursor.name);
}//end function cursorBlink()

function clear()
{
	m_init();
	cursorMove(abs,0,0);
	m_output();
}
/*
clear();
active(1);*/